<template>
    <div class="flex flex-col">
        <div class="overflow-x-auto">
            <div class="py-3 pl-2">
            </div>

            <div class="p-1.5 w-full inline-block align-middle">
                <div class="overflow-hidden border rounded-lg">
                    <table class="min-w-full divide-y divide-gray-200">
                        <thead class="bg-gray-50">
                            <tr>
                                <th scope="col" class="px-6 py-3 text-xs font-bold text-left text-gray-500 uppercase">
                                    ID
                                </th>
                                <th scope="col" class="px-6 py-3 text-xs font-bold text-left text-gray-500 uppercase">
                                    Country
                                </th>
                                <th scope="col" class="px-6 py-3 text-xs font-bold text-left text-gray-500 uppercase">
                                    Town
                                </th>
                                <th scope="col" class="px-6 py-3 text-xs font-bold text-left text-gray-500 uppercase">
                                    Type
                                </th>
                                <th scope="col" class="px-6 py-3 text-xs font-bold text-left text-gray-500 uppercase">
                                    Price
                                </th>
                                <th scope="col" class="px-6 py-3 text-xs font-bold text-right text-gray-500 uppercase">
                                    Actions
                                </th>
                            </tr>
                        </thead>
                        <tbody class="divide-y divide-gray-200">
                            <tr v-for="(property, index) in propertyList">
                                <td class="px-6 py-4 text-sm font-medium text-gray-800 whitespace-nowrap">
                                    {{ index + 1 }}
                                </td>
                                <td class="px-6 py-4 text-sm text-gray-800 whitespace-nowrap">
                                    {{ property.country }}
                                </td>
                                <td class="px-6 py-4 text-sm text-gray-800 whitespace-nowrap">
                                    {{ property.town }}
                                </td>
                                <td class="px-6 py-4 text-sm text-gray-800 whitespace-nowrap">
                                    {{ property.type }}
                                </td>
                                <td class="px-6 py-3 text-xs text-gray-800 whitespace-nowrap">
                                    {{ property.price }}
                                </td>
                                <td class="px-6 py-4 text-sm font-medium text-right whitespace-nowrap">
                                    <div class="flex flex-row-reverse gap-2">
                                        <div @click="redirectToEdit(property.uuid)">
                                            <PencilSquareIcon class="w-5 h-5 text-green-500" />
                                        </div>
                                        <div @click="deleteProperty(property.uuid)">
                                            <TrashIcon class="w-5 h-5 text-red-500" />
                                        </div>
                                    </div>
                                </td>
                            </tr>
                        </tbody>
                    </table>
                </div>
            </div>
        </div>
    </div>
</template>
<script setup>
import { TrashIcon, PencilSquareIcon } from '@heroicons/vue/24/outline'
import { onMounted } from 'vue';
import { usePropertyStore } from '../stores/property';
const propertyStore = usePropertyStore();
const propertyList = ref([]);

const getProperties = async () => {
    await propertyStore.getProperties();
    propertyList.value = propertyStore.properties.data;
}

// delete property

const deleteProperty = async (uuid) => {
    await propertyStore.deleteProperty(uuid);
    alert('Property deleted successfully');
    getProperties();
}

const redirectToEdit = (uuid) => {
    navigateTo(`property/${uuid}`);
}
onMounted(() => {
    getProperties();
})

</script>